#include "stdafx.h"
#include "ScrollBarUI_Img.h"

IMPLEMENT_RTTI(CScrollBarUI_Img, IScrollBarUI)

CScrollBarUI_Img::CScrollBarUI_Img(PSCROLLBARUI_INFO pInfo)
{
	::CopyMemory(&m_Info, pInfo, sizeof(SCROLLBARUI_INFO));

	m_pPanelUI_LeftTop.Attach(new CPanelUI_ScrollBarUI(m_Info.pImgBtn_LeftTop));
	m_pPanelUI_RightBottom.Attach(new CPanelUI_ScrollBarUI(m_Info.pImgBtn_RightBottom));
	CPanelUI_ScrollBarUI_Thumb::THUMBINFO ti;
	ti.pImg1 = m_Info.pImgThumb_1;
	ti.pImg2 = m_Info.pImgThumb_2;
	ti.pImg3 = m_Info.pImgThumb_3;
	ti.pImg4 = m_Info.pImgThumb_4;
	ti.pImg5 = m_Info.pImgThumb_5;
	ti.bHorz = m_Info.bHorz;
	m_pPanelUI_Thumb.Attach(new CPanelUI_ScrollBarUI_Thumb(&ti));
}

CScrollBarUI_Img::~CScrollBarUI_Img()
{
	// [:2008-12-18] Memory Leak  : IImage* deleteϴ ڵ尡 
	if (m_Info.pImgBtn_LeftTop)
		delete m_Info.pImgBtn_LeftTop;
	if (m_Info.pImgBtn_RightBottom)
		delete m_Info.pImgBtn_RightBottom;
	if (m_Info.pImgThumb_1)
		delete m_Info.pImgThumb_1;
	if (m_Info.pImgThumb_2)
		delete m_Info.pImgThumb_2;
	if (m_Info.pImgThumb_3)
		delete m_Info.pImgThumb_3;
	if (m_Info.pImgThumb_4)
		delete m_Info.pImgThumb_4;
	if (m_Info.pImgThumb_5)
		delete m_Info.pImgThumb_5;
	if (m_Info.pImgBgNormal)
		delete m_Info.pImgBgNormal;
	if (m_Info.pImgBgSelected)
		delete m_Info.pImgBgSelected;

	m_Info.pImgBtn_LeftTop = NULL;
	m_Info.pImgBtn_RightBottom = NULL;
	m_Info.pImgThumb_1 = NULL;
	m_Info.pImgThumb_2 = NULL;
	m_Info.pImgThumb_3 = NULL;
	m_Info.pImgThumb_4 = NULL;
	m_Info.pImgThumb_5 = NULL;
	m_Info.pImgBgNormal = NULL;
	m_Info.pImgBgSelected = NULL;
}

void CScrollBarUI_Img::DrawBackground( HDC hDC, CNScrollBar* pNSB, PRECT pRcShaftSelected )
{
	CRect rcNsb;
	pNSB->GetClientRect(&rcNsb);
	m_Info.bHorz = (rcNsb.Width() > rcNsb.Height());

	// {kr} Normal Bg {/kr}
	CRect rcSrc1(0, 0, m_Info.pImgBgNormal->GetWidth(), m_Info.pImgBgNormal->GetHeight());
	CRect rcDest1(&rcNsb);
	m_Info.pImgBgNormal->DrawImage(hDC, &rcSrc1, &rcDest1);

	// {kr} Selected Bg {/kr}
	if (::IsRectEmpty(pRcShaftSelected) == FALSE)
	{
		CRect rcSrc2(0, 0, m_Info.pImgBgSelected->GetWidth(), m_Info.pImgBgSelected->GetHeight());
		m_Info.pImgBgSelected->DrawImage(hDC, &rcSrc2, pRcShaftSelected);
	}
}

IPanelUI* CScrollBarUI_Img::GetLUPanelUI()
{
	return m_pPanelUI_LeftTop.m_p;
}

IPanelUI* CScrollBarUI_Img::GetRDPanelUI()
{
	return m_pPanelUI_RightBottom.m_p;
}

IPanelUI* CScrollBarUI_Img::GetThumbPanelUI()
{
	return m_pPanelUI_Thumb.m_p;
}

IPanelUI* CScrollBarUI_Img::GetHandlePanelUI()
{
	return m_pPanelUI_Thumb.m_p;
}

int CScrollBarUI_Img::GetBtnWidth()
{
	if (m_Info.pImgBtn_LeftTop == NULL) return 0;

	int nBtnWidth = m_Info.pImgBtn_LeftTop->GetWidth() / 4;
	return nBtnWidth;
}

//////////////////////////////////////////////////////////////////////////

IMPLEMENT_RTTI(CScrollBarUI_Img::CPanelUI_ScrollBarUI, IPanelUI)

CScrollBarUI_Img::CPanelUI_ScrollBarUI::CPanelUI_ScrollBarUI(IImage* pImg)
{
	//ATLASSERT(pImg);
	if ( pImg == NULL ) return;

	m_pImg = pImg;
}

CScrollBarUI_Img::CPanelUI_ScrollBarUI::~CPanelUI_ScrollBarUI()
{

}

void CScrollBarUI_Img::CPanelUI_ScrollBarUI::DrawPanel( HDC hDC, CNPanel* pPanel )
{
	ATLASSERT(IS_KIND_OF(CNPanel, pPanel) == TRUE);
	if ( IS_KIND_OF(CNPanel, pPanel) == FALSE ) return;

	CN4StatePanel* p4StatePanel = reinterpret_cast<CN4StatePanel*>(pPanel);
	CN4StatePanel::ePanelState eState = p4StatePanel->GetState();
	
	CRect rcDest;
	pPanel->GetClientRect(&rcDest);

	CRect rcSrc(0, 0, m_pImg->GetWidth() / 4, m_pImg->GetHeight());

	if (eState == CN4StatePanel::E_PANEL_4STATE_NORMAL)
	{
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_OVER)
	{
		rcSrc.MoveToX(rcSrc.Width());
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_DOWN)
	{
		rcSrc.MoveToX(rcSrc.Width() * 2);
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_DIS)
	{
		rcSrc.MoveToX(rcSrc.Width() * 3);
	}

	m_pImg->DrawImage(hDC, &rcSrc, &rcDest);
}

//////////////////////////////////////////////////////////////////////////

IMPLEMENT_RTTI(CScrollBarUI_Img::CPanelUI_ScrollBarUI_Thumb, IPanelUI)

CScrollBarUI_Img::CPanelUI_ScrollBarUI_Thumb::CPanelUI_ScrollBarUI_Thumb(PTHUMBINFO pInfo)
{
	::CopyMemory(&m_Info, pInfo, sizeof(THUMBINFO));
}

CScrollBarUI_Img::CPanelUI_ScrollBarUI_Thumb::~CPanelUI_ScrollBarUI_Thumb()
{

}

void CScrollBarUI_Img::CPanelUI_ScrollBarUI_Thumb::DrawPanel( HDC hDC, CNPanel* pPanel )
{
	ATLASSERT(IS_KIND_OF(CNPanel, pPanel) == TRUE);
	if ( IS_KIND_OF(CNPanel, pPanel) == FALSE ) return;

	CRect rcPanel(0, 0, 0, 0);
	pPanel->GetClientRect(&rcPanel);
	if (rcPanel.IsRectEmpty() == TRUE) return;

	CN4StatePanel* p4StatePanel = reinterpret_cast<CN4StatePanel*>(pPanel);
	CN4StatePanel::ePanelState eState = p4StatePanel->GetState();

	int nMoveMul = 0;
	if (eState == CN4StatePanel::E_PANEL_4STATE_NORMAL)
	{
		nMoveMul = 0;
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_OVER)
	{
		nMoveMul = 1;
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_DOWN)
	{
		nMoveMul = 2;
	}
	else if (eState == CN4StatePanel::E_PANEL_4STATE_DIS)
	{
		nMoveMul = 3;
	}

	CRect rcSrc1(0, 0, m_Info.pImg1->GetWidth() / 4, m_Info.pImg1->GetHeight());
	CRect rcSrc2(0, 0, m_Info.pImg2->GetWidth() / 4, m_Info.pImg2->GetHeight());
	CRect rcSrc3(0, 0, m_Info.pImg3->GetWidth() / 4, m_Info.pImg3->GetHeight());
	CRect rcSrc4(0, 0, m_Info.pImg4->GetWidth() / 4, m_Info.pImg4->GetHeight());
	CRect rcSrc5(0, 0, m_Info.pImg5->GetWidth() / 4, m_Info.pImg5->GetHeight());

	CRect rcDest1(&rcPanel);
	CRect rcDest2(&rcPanel);
	CRect rcDest3(&rcPanel);
	CRect rcDest4(&rcPanel);
	CRect rcDest5(&rcPanel);

	if (m_Info.bHorz == TRUE)
	{
	}
	else
	{
		rcDest1.bottom = rcSrc1.Height();
		rcDest5.top = rcDest5.bottom - rcSrc5.Height();

		rcDest3.top = rcDest3.CenterPoint().y - rcSrc3.Height() / 2;
		rcDest3.bottom = rcDest3.top + rcSrc3.Height();

		rcDest2.top = rcDest1.bottom;
		rcDest2.bottom = rcDest3.top;

		rcDest4.top = rcDest3.bottom;
		rcDest4.bottom = rcDest5.top;
	}
	
	rcSrc1.MoveToX(rcSrc1.Width() * nMoveMul);
	rcSrc2.MoveToX(rcSrc2.Width() * nMoveMul);
	rcSrc3.MoveToX(rcSrc3.Width() * nMoveMul);
	rcSrc4.MoveToX(rcSrc4.Width() * nMoveMul);
	rcSrc5.MoveToX(rcSrc5.Width() * nMoveMul);

	m_Info.pImg1->DrawImage(hDC, &rcSrc1, &rcDest1);
	m_Info.pImg2->DrawImage(hDC, &rcSrc2, &rcDest2);
	m_Info.pImg3->DrawImage(hDC, &rcSrc3, &rcDest3);
	m_Info.pImg4->DrawImage(hDC, &rcSrc4, &rcDest4);
	m_Info.pImg5->DrawImage(hDC, &rcSrc5, &rcDest5);
}